#include <mruby.h>
#include <mruby/compile.h>

int main() {
  mrb_state* mrb;

  char* code =
    "module Sieve\n"
    "  def self.sieve(max)\n"
    "    target = (2..max).to_a\n"
    "    ret = []\n"
    "    until target.empty?\n"
    "      ret << (prime = target.shift)\n"
    "      break if prime * prime > max\n"
    "      target = target.reject {|i| i % prime == 0 }\n"
    "    end\n"
    "    ret + target\n"
    "  end\n"
    "end\n"
    "sieve = Sieve.sieve(10000)\n"
    "print sieve.first(10), '...', sieve.last(10), \"\\n\"\n"
    ;
  mrb = mrb_open();
  mrb_load_string(mrb, code);
  mrb_close(mrb);
  return 0;
}
